\begin{foobar}
Here is some verbatim
stuff:

\begin{verbatim}
  this indentation is completely wrong
        and
                would
immediately       be \\changed
\end{verbatim}

\begin{verbatim}and this slash would trigger an error
\\end{verbatim}

And here is some more text

And another \begin{Verbatim}V  e  r  b  a  t  im mode\end{Verbatim}

It can                even      be \verb,i n l in  e,! Inline mode should \verb(att        empt( to wrap, and \verb$shou$ l d e v e n h a n d l e c o u n t i n g c h a r a c t e r s c o r r e c t l y s o t h a t l a t e r l i n e w r a p s h a p p e n c o r r e c t l y

Of course, inline can have \verb?newlines attached to it




as well, and these should work   right?, and all that stuff about wrapping should also work right.
\end{foobar}